import java.awt.*;
import java.util.*;
import java.io.*;
import java.lang.*;

public class Courbe {
	int nftrdim=10;
	double xmin,ymin,xmax,ymax,width,height,x0,y0,facx,facy,buf;
	int[] xg, yg;
	double[] x, y, xpv, ypv;
	double[][] vxv, vyv;
        double[][] coeff;
        int npg=10, npv=-1, nvv=-1;
        int xpg[][],ypg[][], xpvg[], ypvg[];
	int imax, nemax, nfmax, nbd;
	int i0,j0,x3,y3,x4,y4,i1,j1;
	String filename;
	int pb[], tri[][], itm[][], pseg[][], tseg[][];
	int nmit[], imit[], tmit[];
	int nfbd, fbd[], fbdr[], zero[], flagzero;
	int nxp, nyp, nxc, nyc;
	int xc,yc; 
	private Vector result;
	private static Color[] colors= {
	Color.white, Color.red, Color.yellow, Color.orange,
	Color.pink, Color.green, Color.cyan, Color.pink, Color.magenta,
	Color.blue};
	private double[][] parazoom, parabuf;
	private int nzoom=0;
    private int current=-1;
    private int nsquares=0;
    private Point[] square = new Point[100];
    private static final int SQUARELENGTH=10;
    private int pclick[],pnodebdy[][];


	public Courbe() {
	}
	
	public Vector zoom(int x1, int y1, int x2, int y2, int width1, int
	height1, int dzoom ) {
		double facmin;
                double u,sum,a,b,xx1,yy1,xx2,yy2,ax,bx,ay,by;
                int face,cell,n1,n2,n3;
	
		nxp=width1;
		nyp=height1;
		nxc=nxp/2;
		nyc=nyp/2;
		i0 = nxc;
		j0 = nyc;

		x3 = Math.min( x1, x2 );
		y3 = Math.min( y1, y2 );
		x4 = Math.max( x1, x2 );
		y4 = Math.max( y1, y2 );
		i1 = x4 - x3;
		j1 = y4 - y3;

		if (i1 == 0) {
			nzoom=1;
			this.initsize();
		}
		else if (dzoom > 0) {
			 nzoom++;
			 this.increasesize();
		}
		else if (dzoom < 0) {
			 nzoom--;
			 if (nzoom==0) {
				nzoom=1;
				this.initsize();
			}
			else {
			 	x0=parazoom[nzoom-1][0];
			 	y0=parazoom[nzoom-1][1];
			 	facx=parazoom[nzoom-1][2];
			 	facy=parazoom[nzoom-1][3];
			}
		}

		for (int i=0; i< imax; i++) {
			buf =  facx * (x[i] - x0);
		      xg[i] = (int)buf + i0;
			buf = -facy * (y[i] - y0);
		      yg[i] = (int)buf + j0;
		}
                for (int i=0; i<nfbd; i++) {
                      a = coeff[i][0];
                      b = coeff[i][1];
                      face = fbd[i];
                      cell = tseg[face][0];
                      n1 = tri[cell][0];
                      n2 = tri[cell][1];
                      n3 = tri[cell][2];
                      ax = (x[n2]-x[n1]) *0.5;
                      bx = (x[n3]-x[n1]) *0.5;
                      ay = (y[n2]-y[n1]) *0.5;
                      by = (y[n3]-y[n1]) *0.5;
                      for (int k=0; k<=npg; k++) {
                          u = 2.0 * (double)k / (double)npg - 1.0;
                          sum = u*u - 1.0;
                          xx1 = u - b * sum *0.5;
                          yy1 = -1.0 + (a+b) * sum *0.5;
                          xx2= x[n1] + (ax * (xx1+1.0) + bx * (yy1+1.0));
                          yy2= y[n1] + (ay * (xx1+1.0) + by * (yy1+1.0));
			  buf =  facx * (xx2 - x0);
		          xpg[i][k] = (int)buf + i0;
			  buf = -facy * (yy2 - y0);
		          ypg[i][k] = (int)buf + j0;
                      }
                }
		for (int i=0; i< npv; i++) {
			buf =  facx * (xpv[i] - x0);
		      xpvg[i] = (int)buf + i0;
			buf = -facy * (ypv[i] - y0);
		      ypvg[i] = (int)buf + j0;
		}

		result = new Vector();
		Integer ii = new Integer(i0);
		Integer jj = new Integer(j0);
		result.add(ii);
		result.add(jj);
		Double facxx = new Double(facx);
		Double facyy = new Double(facy);
		result.add(facxx);
		result.add(facyy);
		Double xc = new Double(x0);
		Double yc = new Double(y0);
		result.add(xc);
		result.add(yc);

		return result;
	}

	public void initsize() {
		int i,j;
		double facmin;

		x0 = 0.5 * ( xmin + xmax );
		y0 = 0.5 * ( ymin + ymax );
		width  =  xmax - xmin;
		height =  ymax - ymin;
		facx = (double)nxp /width;
		facy = (double)nyp /height;
		facx *=0.9;
		facy *=0.9;
		facmin = Math.min( facx, facy );
		facx = facmin;
		facy = facmin;

		parazoom=new double[nzoom][4];
		parazoom[nzoom-1][0]=x0;
		parazoom[nzoom-1][1]=y0;
		parazoom[nzoom-1][2]=facx;
		parazoom[nzoom-1][3]=facy;
	}

	public void increasesize() {
		int i,j;
		double facmin;

		xc=(x3+x4)/2-i0;
		yc=(y3+y4)/2-j0;
		x0 =  (double)(xc)/facx + x0;
		y0 = -(double)(yc)/facx + y0;
		
		facx = facx * (double)nxp / ( i1 );
		facy = facy * (double)nyp / ( j1 );
		facmin = Math.min( facx, facy );
		facx = facmin;
		facy = facmin;

		parabuf=new double[nzoom][4];
		for (i=0; i<nzoom-1; i++) {
		 for (j=0; j<4; j++) {
		 	parabuf[i][j]=parazoom[i][j];
		 }
		}
		parazoom=new double[nzoom][4];
		for (i=0; i<nzoom-1; i++) {
		 for (j=0; j<4; j++) {
		 	parazoom[i][j]=parabuf[i][j];
		 }
		}
		parazoom[nzoom-1][0]=x0;
		parazoom[nzoom-1][1]=y0;
		parazoom[nzoom-1][2]=facx;
		parazoom[nzoom-1][3]=facy;
	}

	public void dessine(Graphics g) {
		int i,i1,i2,j,k;
		int flag;
		for (i=0; i< nfmax; i++) {
		    i1=pseg[i][0];
		    i2=pseg[i][1];
		    flag=pb[i];
		    g.setColor(colors[flag]);
                    if (fbdr[i]>-1) {
                      j=fbdr[i];
		      g.drawPolyline( xpg[j], ypg[j], npg+1);
                    }
                    else {
		     g.drawLine( xg[i1], yg[i1], xg[i2], yg[i2] );}
		}
		g.setColor(colors[5]);
		g.drawPolygon( xpvg, ypvg, npv);
	}

	public void selection(int bdyflag) {
		int i, face;
		for (i=0; i< nfbd; i++) {
		    if (pclick[i] == 1) {
		      face = fbd[i]; pb[face]=bdyflag; pclick[i]=0;
		    }
		}
	}

	public void UnSelection() {
		int i, face;
		for (i=0; i< nfbd; i++) {
		    if ( pclick[i]==1 ) {face = fbd[i]; pb[face]=1;}
		}
	}

	public void findClicked1(int x1, int y1) {
		int i, i1, i2, face;
		int xm, ym, x2, y2;
		int xclose, yclose, close=5;
		double xd,yd;
		for (i=0; i< nfbd; i++) {
		    face = fbd[i];
		    i1=pseg[face][0];
		    i2=pseg[face][1];
		    xm = (xg[i1]+xg[i2])/2;
		    ym = (yg[i1]+yg[i2])/2;
		    x2 = Math.abs(xm-x1);
		    y2 = Math.abs(ym-y1);
		    xclose=Math.abs(xg[i1]-xg[i2]);
		    yclose=Math.abs(yg[i1]-yg[i2]);
		    xd = (double) xclose; yd = (double) yclose;
		    close = (int) Math.sqrt(xd*xd+yd*yd)/4;
		    if ( x2 < close && y2 < close ) { 
		       if (pclick[i] != 1) pclick[i] = 1;
 		       else pclick[i] = 0;
		    }
		}
	}

	public void findClicked2(int x1, int y1, int x2, int y2) {
		int i, i1, i2, face;
		int xm, ym;
		x3 = Math.min( x1, x2 );
		y3 = Math.min( y1, y2 );
		x4 = Math.max( x1, x2 );
		y4 = Math.max( y1, y2 );
		for (i=0; i< nfbd; i++) {
		    face = fbd[i];
		    i1=pseg[face][0];
		    i2=pseg[face][1];
		    xm = (xg[i1]+xg[i2])/2;
		    ym = (yg[i1]+yg[i2])/2;
		    if ( xm > x3 && xm < x4 
		      && ym > y3 && ym < y4 ) pclick[i] = 1;
		}
	}

	public void SelectClicked() {
		int i, i1, i2, face;
		int xm, ym;
		nsquares=0;
		for (i=0; i< nfbd; i++) {
		    if (pclick[i] == 1) {
		        face = fbd[i];
		    	i1=pseg[face][0];
		    	i2=pseg[face][1];
		    	xm = (xg[i1]+xg[i2])/2;
		    	ym = (yg[i1]+yg[i2])/2;
                        square[nsquares]=new Point(xm,ym);
			nsquares++;
	            }
		}
	}

	public void drawClicked(Graphics g) {
		int i;
		for (i=0; i< nsquares; i++) {
		    g.setColor(Color.red);
          	    g.drawRect(square[i].x - SQUARELENGTH /2,
                     square[i].y - SQUARELENGTH /2,
                     SQUARELENGTH,SQUARELENGTH);
		}
	}

	public void fact() {
		
		xmin = x[1];
		ymin = y[1];
		xmax = x[1];
		ymax = y[1];

		for (int i=0; i< imax; i++) {
			xmin = Math.min( xmin, x[i] );
			ymin = Math.min( ymin, y[i] );
			xmax = Math.max( xmax, x[i] );
			ymax = Math.max( ymax, y[i] );
		}
	}

   	public void ReadMesh(String filename){
	        StringTokenizer st;
		DataInputStream input;
 		String line;
		int i = -1;
		int j;

// read the point location from the mesh file

		try{ 
// first read the number of points
             	    input = new DataInputStream(
                    new FileInputStream(filename) );
		    line = input.readLine();
		    st = new StringTokenizer(line," ");
		    imax  = Integer.parseInt (st.nextToken());
		    nemax = Integer.parseInt (st.nextToken());
// then allocate memory
		    x = new double[imax];
		    y = new double[imax];
		    xg = new int[imax];
		    yg = new int[imax];
		    tri = new int[nemax][3];
// then read the point positions
	            for ( i=0; i<imax; i++ ) {
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      j    = Integer.parseInt (st.nextToken());
		      x[i] = Double.parseDouble (st.nextToken());
		      y[i] = Double.parseDouble (st.nextToken()) ;
	            }
		    System.out.println(imax+" points read with success");
// then read the connection
	            for ( i=0; i<nemax; i++ ) {
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      j         = Integer.parseInt (st.nextToken());
		      tri[i][0] = Integer.parseInt (st.nextToken());
		      tri[i][1] = Integer.parseInt (st.nextToken());
		      tri[i][2] = Integer.parseInt (st.nextToken());
		      for (j=0; j<3; j++) tri[i][j]--;
 	            }
		    System.out.println(nemax+" triangles read with success");
		    input.close();
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	   System.exit(1);
        	}

	}
	
   	public void SaveMesh(String filename){
		int i,j,i1,i2,i3;
		int face, flag;
		
		try{ 
             	    PrintStream output = new PrintStream(
                    new FileOutputStream(filename) );
		    for (i=0; i<imax;i++) {
		        j=i+1;
			output.println(j+"  "+x[i]+" "+y[i]);
		    }
		    System.out.println(imax+" nodes saved with success");
		    for (i=0; i<nemax;i++) {
		        j=i+1; 
			i1=tri[i][0]+1; 
			i2=tri[i][1]+1; 
			i3=tri[i][2]+1; 
			output.println(j+"   "+i1+" "+i2+" "+i3);
		    }
		    System.out.println(nemax+" elements saved with success");
		    output.close();
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	}

	}



// read the segment flag from a bel file

   	public void ReadBel(String filename){
	        StringTokenizer st;
		DataInputStream input;
 		String line;
		int i = -1;
		int j, i1,i2,face1,face2;

		try{ 
             	    input = new DataInputStream(
                    new FileInputStream(filename) );
	            for ( i=0; i<nfbd; i++ ) {
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      j    = Integer.parseInt (st.nextToken());
		      i1    = Integer.parseInt (st.nextToken());
		      i2    = Integer.parseInt (st.nextToken());
		      i1--; i2--;
		      face1=pnodebdy[i1][1];
		      face2=pnodebdy[i2][0];
		      if (face1==face2)
		      pb[face1] = Integer.parseInt (st.nextToken());
	            }
		    System.out.println(nfbd+" segments read with success");
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	   System.exit(1);
        	}
	}

   	public void SaveBel(String filename){
		int i,face,i1,i2;

		try{ 
             	    PrintStream output = new PrintStream(
                    new FileOutputStream(filename) );
		    for (i=0; i<nfbd; i++) {
		      face = fbd[i];
		      i1=pseg[face][0]+1;
		      i2=pseg[face][1]+1;
		      output.println(i+"  "+i1+" "+i2+" "+pb[face]);
		    }
		    System.out.println(nfbd+" faces saved with success");
		    output.close();
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	}
	}

// read the parabolic coefficients for the bdy face

   	public void ReadCoef(String filename){
	        StringTokenizer st;
		DataInputStream input;
 		String line;
		int i = -1;
		int j,i1,i2,face1,face2;
                double a,b;

		try{ 
             	    input = new DataInputStream(
                    new FileInputStream(filename) );
	            for ( i=0; i<nfbd; i++ ) {
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      j    = Integer.parseInt (st.nextToken());
		      i1    = Integer.parseInt (st.nextToken());
		      i2    = Integer.parseInt (st.nextToken());
		      i1--; i2--;
		      face1=pnodebdy[i1][1];
		      face2=pnodebdy[i2][0];
		      a = Double.parseDouble (st.nextToken());
		      b = Double.parseDouble (st.nextToken()) ;
		      if (face1==face2) {
                        j=fbdr[face1];
		        coeff[j][0] = a;
		        coeff[j][1] = b;
                      }
	            }
		    System.out.println(nfbd+" segments read with success");
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	   System.exit(1);
        	}
	}

// save the parabolic coefficients for the bdy face

   	public void SaveCoef(String filename){
		int i1,i2,face;
                double a,b;

		try{ 
             	    PrintStream output = new PrintStream(
                    new FileOutputStream(filename) );
		    for (int i=0; i<nfbd; i++) {
		      face = fbd[i];
		      i1=pseg[face][0]+1;
		      i2=pseg[face][1]+1;
		      a=coeff[i][0];
		      b=coeff[i][1];
		      output.println(i+"  "+i1+" "+i2+"  "+a+" "+b);
		    }
		    System.out.println(nfbd+" faces saved with success");
		    output.close();
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	}
	}

// read the true boundary points

   	public void ReadTrueBD(String filename){
	        StringTokenizer st;
		DataInputStream input;
 		String line;
		int i;

		try{ 
             	    input = new DataInputStream(
                    new FileInputStream(filename) );
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      npv = Integer.parseInt (st.nextToken());
                      xpv  = new double[npv];
                      ypv  = new double[npv];
                      xpvg = new int[npv];
                      ypvg = new int[npv];
	            for ( i=0; i<npv; i++ ) {
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      xpv[i] = Double.parseDouble (st.nextToken());
		      ypv[i] = Double.parseDouble (st.nextToken()) ;
	            }
		    System.out.println(npv+" points read with success");
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened properly");
        	   System.exit(1);
        	}
	}

// read the true boundary tangents at mesh bdy points

   	public void ReadTrueBDV(String filename){
	        StringTokenizer st;
		DataInputStream input;
 		String line;
		int i;

		try{ 
             	    input = new DataInputStream(
                    new FileInputStream(filename) );
	            for ( i=0; i<nfbd; i++ ) {
		      line = input.readLine();
		      st = new StringTokenizer(line," ");
		      i1    = Integer.parseInt (st.nextToken());
		      i1--; 
		      vxv[i1][0] = Double.parseDouble (st.nextToken());
		      vxv[i1][1] = vxv[i1][0];
		      vyv[i1][0] = Double.parseDouble (st.nextToken()) ;
		      vyv[i1][1] = vyv[i1][0];
 	            }
		    System.out.println(nfbd+" vectors read with success");
        	}
        	catch (IOException e){
        	   System.err.println("File "+filename+" not opened or read properly");
        	   System.exit(1);
        	}
	}

	public void maille() {
  		int[] ndeb, nfin;
  		int i,j,ind,k,tk,ik,lk,pj,it,ne1,ne2,ne3,
      			i1,i2,nc,nd,buf,j1,j2;
  		int trouve;
  		int ideb,ifin;

		ndeb = new int[imax+1];
		nfin = new int[imax+1];
		pseg = new int[3*imax][2];
		tseg = new int[3*imax][2];
  		nmit = new int[imax+1];
  		tmit = new int[nftrdim*imax];
  		imit = new int[nftrdim*imax];
		itm = new int[nemax][3];

  		for (i=0; i<3*imax; i++) {
	   	tseg[i][0]=-1;
	   	tseg[i][1]=-1;
  		}

/*c
c triangles (elements) mitoyens d'un noeud
c on suppose que chaque noeud est entoure de nftrdim quadrilateres
c et on remplit les vecteurs tmit et imit
c*/
      ndeb[0]=0;
      nfin[0]=0;
      for (i=0; i<imax-1; i++) {
           ndeb[i+1]=ndeb[i]+nftrdim;
           nfin[i+1]=ndeb[i+1];
      }

      for (i=0; i<nemax; i++) {
           for (k=0; k<3; k++) {
              ne1 = tri[i][k];
              ind = nfin[ne1];
              tmit[ind] = i;
              imit[ind] = k;
              nfin[ne1] = ind+1;
	      if ( ne1 < imax-1 ) {
              while ( nfin[ne1] == ndeb[ne1+1] ) {
                 ne1++;
                 for (j1=nfin[ne1]-1; j1>=ndeb[ne1]; j1--) {
                    tmit[j1+1] = tmit[j1];
                    imit[j1+1] = imit[j1];
                 }
                 ndeb[ne1]++;
                 nfin[ne1]++;
              }
              }
	   }
      }
/*c
c elimination des vides laisses dans tmit et imit
c*/
       ind=-1;
       for (i=0; i<imax; i++) {
           for (j=ndeb[i]; j<=nfin[i]-1; j++) {
               ind++;
               tmit[ind] = tmit[j];
               imit[ind] = imit[j];
           }
       }
       nmit[0]=0;
       for (i=0; i<imax; i++) {
           nmit[i+1] = nmit[i] + nfin[i] - ndeb[i];
       }

/* --------------------------
   find the faces of the mesh
   -------------------------*/

      nfmax = -1;
      for (i=0; i<nemax; i++) {
         for (j=0; j<3; j++) {
            ne1=tri[i][j];
            if (j == 2) {
	    	ne2 = tri[i][0]; }
   	    else {
	        ne2 = tri[i][j+1];
	    }
/*c
c   checker les anciennes faces des elements mitoyens
c*/
            k = nmit[ne2];
            tk = tmit[k];
            trouve = 1;
            ik = imit[k];            
            while(tk < i && trouve == 1) {
              if (ik == 2) {
	    	ne3 = tri[tk][0]; }
   	      else {
	        ne3 = tri[tk][ik+1];
	      }
               if (ne1 == ne3) {
                  lk = itm[tk][ik];
                  tseg[lk][1] = i;
                  itm[i][j] = lk;
                  trouve = 0;
               }
               k++;
               tk = tmit[k];
               ik = imit[k];           
            }
/*c
c la face est nouvelle!
c*/
            if (trouve == 1) {
               nfmax++;
               itm[i][j] = nfmax;
               tseg [nfmax] [0] = i;
               pseg [nfmax] [0] = ne1;
               pseg [nfmax] [1] = ne2;
            }
         }      
      }
      nfmax++;
      pb = new int[nfmax];
      for (i=0; i<nfmax; i++) pb[i] = 0;


// ************* find the boundary faces ************* //

      nfbd=0;
      for (i=0; i<nfmax; i++) {
          if (tseg[i][1]==-1) nfbd++;
      }
      fbd = new int[nfbd+1];
      fbdr = new int[nfmax];
      pclick = new int[nfbd];
      pnodebdy= new int[imax][2];
      coeff = new double[nfbd][2];
      xpg = new int[nfbd][npg+1];
      ypg = new int[nfbd][npg+1];
      vxv = new double[imax][2];
      vyv = new double[imax][2];
      
      for (i=0; i<imax; i++) {
          pnodebdy[i][0]=-1;
          pnodebdy[i][1]=-1;
      }
      j=-1;
      for (i=0; i<nfmax; i++) {
          i1 = pseg[i][0];
	  i2 = pseg[i][1];
          fbdr[i]=-1;
          if (tseg[i][1]==-1) {
	  j++;
	  fbd[j]=i;
	  fbdr[i]=j;
	  pb[i]=1;
	  pclick[j]=0;
	  pnodebdy[i1][1]=i;
	  pnodebdy[i2][0]=i;
	  }
      }
      
       System.out.println("number of faces "+nfmax);
       System.out.println("number of faces along bdy "+nfbd);
}

   	public void ProjStr(){
		int i;
		double r,ang;
		for (i=0; i<imax; i++) {
		    ang = y[i];
		    ang *= Math.PI/180;
		    r = Math.cos(ang)/( 1.0 + Math.sin(ang) );
		    ang=x[i];
		    ang *= Math.PI/180;
		    x[i]= r * Math.cos(ang);
		    y[i]= r * Math.sin(ang);
		}
	}

// ******** compute the parabolic coefficients for the bdy face ***********

   	public void ComputeCoef(){
		int n1,n2,n3,face,cell;
                double a=0,b=0,ax,ay,bx,by,px1,py1,px2,py2,
		xx2,yy2,xx1,yy1,delta,du1,dv1,du2,dv2,a0,a1,a2,c1,c2,
		u0,u1,v1;
		
		zero = new int[nfbd];
		flagzero = 0;

		for (int i=0; i<nfbd; i++) {
		      zero[i] = 0;
		      face = fbd[i];
		      cell=tseg[face][0];
                      n1 = tri[cell][0];
                      n2 = tri[cell][1];
                      n3 = tri[cell][2];
                      ax = (x[n2]-x[n1]) *0.5;
                      bx = (x[n3]-x[n1]) *0.5;
                      ay = (y[n2]-y[n1]) *0.5;
                      by = (y[n3]-y[n1]) *0.5;
		      delta = ax * by - ay * bx;
		      px1=vxv[n1][1]; py1=vyv[n1][1];
		      px2=vxv[n2][0]; py2=vyv[n2][0];
		      xx1 =  ( px1 * by - py1 * bx ) / delta;
		      yy1 = -( px1 * ay - py1 * ax ) / delta;
		      xx2 =  ( px2 * by - py2 * bx ) / delta;
		      yy2 = -( px2 * ay - py2 * ax ) / delta;
		      du1 = xx1 + yy1 * 0.5;
		      dv1 = yy1;
		      du2 = xx2 + yy2 * 0.5;
		      dv2 = yy2;
		      a0 = Math.PI*0.25;
		      a1 = Math.abs(Math.atan2( dv1, du1));
		      a2 = Math.abs(Math.atan2( dv2, du2));
		      if ( a1 < a0 && a2 < a0) {
		         c1 = dv1/du1; c2 = dv2/du2;
			 u0 = (c2-c1)*0.5;
			 if (Math.abs(u0) > 1.0e-6) {
			   v1 = -(c1+c2)/u0;
			   u1 = -c1*c2/u0;
			   a  = (u1+v1)*0.5;
			   b  = (u1-v1)*0.5;
			 }
			 else {
			   v1=0.0; a=0.0; b=0.0;
                         }
                         if ( Math.abs(v1) > 1.0 ) {
		          zero[i]=1;
			  flagzero=1;
			  }
		      }
		      else {
                          a=0; b=0;
		          zero[i]=1;
			  flagzero=1;
		      }

		      coeff[i][0]=a;
		      coeff[i][1]=b;
        	}

		if (flagzero==1) set_to_zero();
		else System.out.println("No major problem detected");
	}

  	public void set_to_zero() {
		int n1,n2,face,cell;

		for (int i=0; i<nfbd; i++) {
		  if (zero[i] == 1) {
		       coeff[i][0]=0.0;
		       coeff[i][1]=0.0;

		       face = fbd[i];
		       pb[face]=9;
		       cell=tseg[face][0];
                       n1 = tri[cell][0];
                       n2 = tri[cell][1];
		       vxv[n1][1] = x[n2]-x[n1];  vyv[n1][1] = y[n2]-y[n1];
		       vxv[n2][0] = x[n2]-x[n1];  vyv[n2][0] = y[n2]-y[n1];
//		       vxv[n1][0] = x[n2]-x[n1];  vyv[n1][0] = y[n2]-y[n1];
//		       vxv[n2][1] = x[n2]-x[n1];  vyv[n2][1] = y[n2]-y[n1];
		      System.out.println(
		      "force to set to zero the curvature for face: "+i+
		      " and vector at nodes "+n1+" "+n2);
		  }
                }
	}

// ******** compute the cubic spline coefficients ***********

   	public void CubicSplineInit(){
	 int nsp=-1, nsp0=-1;
               double[] tsp,xsp,ysp,dsp;
	int i,j, n2, face, k=0;
	int sp2gr[], pfp[], psp0[];

               tsp=new double[nfbd+1];
               dsp=new double[nfbd+1];
               xsp=new double[nfbd+1];
               ysp=new double[nfbd+1];
	sp2gr=new int[nfbd+1];
	pfp=new int[nfmax];
	psp0=new int[nfbd];
		
	for (i=0; i<nfbd; i++) {face=fbd[i]; pfp[face]=1;}
		
		
//****** loop for all boundary/islands ********
		
	  i=0;
		
	  while (i<nfbd) {
		
		System.out.println("bdy number:"+k+" "+i+" "+nfbd);

//****** find first face on bdy unused ********

		face = fbd[i];
		while ( i <nfbd && pfp[face]==0) {i++; face = fbd[i];}
		
		
		k++;
		System.out.println("bdy number:"+k+" starting at "+i);
		if (i<nfbd && pfp[face]==1) {
		  nsp=findsp_point(i,xsp,ysp,tsp,dsp,pfp,sp2gr);
		  nsp0=findsp0_point(i,sp2gr,psp0);
		  System.out.println("nb of pts along bdy:"+nsp);
		  System.out.println("nb of pts along bdy to zero:"+nsp0);
		  compute_sp(nsp,dsp,xsp,ysp,sp2gr,nsp0,psp0);
		}
		
	  }
		
	}
	
	
//***** find the spline points along any boundary/island *****//

	int findsp_point(int i, 
	         double xsp[], double ysp[], double tsp[], double dsp[], 
		 int pfp[], int sp2gr[]) {

	  int face, face_old, j, n1, n2;

		j=-1;
		face = fbd[i];
		pfp[face]=0;
		n1 = pseg[face][0];
		n2 = pseg[face][1];
		j++;
		xsp[j]=x[n1];
		ysp[j]=y[n1];
		tsp[j]=0.0;
		sp2gr[j]=n1;
		j++;
		xsp[j]=x[n2];
		ysp[j]=y[n2];
		dsp[j-1]= Math.sqrt((x[n2]-x[n1])*(x[n2]-x[n1])
		                + (y[n2]-y[n1])*(y[n2]-y[n1]));
//		dsp[j]= 1.0;
		tsp[j]=tsp[j-1]+dsp[j-1];
		sp2gr[j]=n2;
		face_old=face;
		face=pnodebdy[n2][1];
		pfp[face]=0;

		while (face != face_old) {
		      n1 = pseg[face][0];
		      n2 = pseg[face][1];
		      j++;
		      dsp[j-1]= Math.sqrt((x[n2]-x[n1])*(x[n2]-x[n1])
		                      + (y[n2]-y[n1])*(y[n2]-y[n1]));
//		      dsp[j]= 1.0;
		      tsp[j]=tsp[j-1]+dsp[j-1];
		      xsp[j]=x[n2];
		      ysp[j]=y[n2];
		      sp2gr[j]=n2;
		      face=pnodebdy[n2][1];
		      pfp[face]=0;
		}
		
		j++;
		return j;
	}
		

//***** find the spline points along any boundary/island *****//

	int findsp0_point(int i, int sp2gr[], int psp0[]) {

	  int face, face_old, j, n1, n2, nz, pf1, pf2, sum;

		nz=0;
		j=0;
		face = fbd[i];
		pf2 = pb[face];
		
		n1 = pseg[face][0];
		n2 = pseg[face][1];
		
		face=pnodebdy[n1][0];
		pf1 = pb[face];
		sum = pf2 - pf1;
		
		if (sum!=0) {psp0[nz]=j; nz++;}
		
		pf1=pf2;

		j++;
		face_old=face;
		face=pnodebdy[n2][1];
		pf2 = pb[face];
		sum = pf2 - pf1;
		if (sum!=0) {psp0[nz]=j; nz++;}
		pf1=pf2;


		while (face != face_old) {
		      n1 = pseg[face][0];
		      n2 = pseg[face][1];
		      j++;
		      face=pnodebdy[n2][1];
		      pf2 = pb[face];
		      sum = pf2 - pf1;
		      if (sum!=0) {psp0[nz]=j; nz++;}
		      pf1=pf2;
		}

		return nz;
	}
		

//***** compute spline coefficient *****//

	void compute_sp(int nsp, double dsp[], double xsp[], double ysp[], 
	             int sp2gr[], int nsp0, int psp0[]) {

                double[] matsp,bxsp,bysp;
		double[][] dxsp, dysp;
		int i, j, n2;
		int iasp[], jasp[];

		matsp=new double[nsp*3];
		bxsp=new double[nsp];
		bysp=new double[nsp];
		iasp= new int[nsp+1];
		jasp= new int[nsp*3];
                dxsp=new double[nsp][2];
                dysp=new double[nsp][2];
		
		iasp[0]=0;
		j=-1;
		
		i=0;
		j++;
		jasp[j]=i;
		matsp[j] = (dsp[nsp-2]+dsp[i])/3.0;
		j++;
		jasp[j]=i+1;
		matsp[j] = dsp[i]/6.0;
		j++;
		jasp[j]=nsp-2;
		matsp[j] = dsp[nsp-2]/6.0;
		bxsp[i] = (xsp[i+1]-xsp[i])    /dsp[i]
		        - (xsp[i]  -xsp[nsp-2]) /dsp[nsp-2];
		bysp[i] = (ysp[i+1]-ysp[i])    /dsp[i] 
		        - (ysp[i]  -ysp[nsp-2]) /dsp[nsp-2];
		iasp[i+1]=j+1;
		
		for (i=1; i <nsp-2; i++) {
		  j++;
		  jasp[j]=i-1;
		  matsp[j] = dsp[i-1]/6.0;
		  j++;
		  jasp[j]=i;
		  matsp[j] = (dsp[i-1]+dsp[i])/3.0;
		  j++;
		  jasp[j]=i+1;
		  matsp[j] = dsp[i]/6.0;
		  bxsp[i] = (xsp[i+1]-xsp[i]) /dsp[i] - (xsp[i]-xsp[i-1]) /dsp[i-1];
		  bysp[i] = (ysp[i+1]-ysp[i]) /dsp[i] - (ysp[i]-ysp[i-1]) /dsp[i-1];
		  iasp[i+1]=j+1;
		}
		   
		i=nsp-2;
		j++;
		jasp[j]=0;
		matsp[j] = dsp[i]/6.0;
		j++;
		jasp[j]=i-1;
		matsp[j] = dsp[i-1]/6.0;
		j++;
		jasp[j]=i;
		matsp[j] = (dsp[i-1]+dsp[i])/3.0;
		bxsp[i] = (xsp[0]-xsp[i]) /dsp[i] - (xsp[i]-xsp[i-1]) /dsp[i-1];
		bysp[i] = (ysp[0]-ysp[i]) /dsp[i] - (ysp[i]-ysp[i-1]) /dsp[i-1];
		iasp[i+1]=j+1;


// ********** if there is a change in boundary condition for faces 
//            the 2nd derivatives are zeroed ***********

                for (i=0; i<nsp0; i++) {
		  j=psp0[i];
		  zero_spline(j,iasp,jasp,matsp,bxsp,bysp);
		  System.out.println("zero 2nd deriv at "+sp2gr[j]);
		}


// ********* solve the matrix problem

		pcgm(matsp,bxsp,nsp-1,iasp,jasp);
		pcgm(matsp,bysp,nsp-1,iasp,jasp);
		
                dev_sp(nsp,xsp,ysp,bxsp,bysp,dsp,dxsp,dysp);


		for (i=0; i<nsp-1; i++) {
		     n2=sp2gr[i];
		     vxv[n2][0] = dxsp[i][0];
		     vyv[n2][0] = dysp[i][0];
		     vxv[n2][1] = dxsp[i][1];
		     vyv[n2][1] = dysp[i][1];
		}

	}
		

/*C***********************************************************************

Conjugate gradient solver routine

C***********************************************************************
*/
      void pcgm(double A[], double x[], int nn, int iq[], int jq[]) {
/*c-----+----------------------------------------------------------------+
c Solve Ax=b by the preconditioned conjugate gradient method, where
c A is a sparse, symmetric and positiv definite matrix, b a known 
c vector, and x the unknown vector. In the call b is x.
c The preconditioner C is a diagonal matrix stored in a vector.
c 
c Nicolai Kliem, 11 Feb. 1998
c-----+----------------------------------------------------------------+
*/

      double[] p,r,w,b,z,C;
      double alpha,beta,rz,rznew,rzstop,pw,epsilon=1.e-12;
      int i,j,l,k,n,kmax;

      p = new double[nn];
      r = new double[nn];
      w = new double[nn];
      b = new double[nn];
      z = new double[nn];
      C = new double[nn];
/*c-----+----------------------------------------------------------------+
c Initialize
c x=0
c-----+----------------------------------------------------------------+

c The preconditioner C could be calculated once and forever in 
c subroutine STATIONARYQ4, but this recuires that the C is transfered
c through the subroutine calls, and is not implemented here to make as
c few changes as possible.
*/
      for (n=0; n<nn; n++) {
        j=calja(n,n,iq,jq);
        C[n]=1.0/A[j];
      }

      for (n=0; n<nn; n++) {
        r[n]=x[n];
        b[n]=x[n];
        x[n]=0.0;
      }

      for (n=0; n<nn; n++) {
        z[n]=C[n]*r[n];
        p[n]=z[n];
      }

      rz=0.;
      for (n=0; n<nn; n++) {
        rz=rz+r[n]*z[n];
      }

      k=0;
      kmax=nn;
      rzstop=epsilon*rz;

/*c-----+----------------------------------------------------------------+
c Loop
c-----+----------------------------------------------------------------+
*/
      while (k < kmax && rz > rzstop) {
/*c
c w=A*p
c*/
        for (i=0; i<nn; i++) {
	   w[i]=0.0;
	   for (j=iq[i]; j<iq[i+1]; j++) {
	      l=jq[j];
	      w[i] = w[i] + A[j]*p[l];
	   }
        }
/*c
c alpha=rz/(pT*w)
c*/
        pw=0.;
        for (n=0; n<nn; n++) {
          pw=pw+p[n]*w[n];
        }
        alpha=rz/pw;
/*c
c x=x+alpha*p
c*/
        for (n=0; n<nn; n++) {
          x[n]=x[n]+alpha*p[n];
        }
/*c
c r=r-alpha*w
c*/
        for (n=0; n<nn; n++) {
          r[n]=r[n]-alpha*w[n];
        }
/*c
c z=C-1*r
c*/
        for (n=0; n<nn; n++) {
          z[n]=C[n]*r[n];
        }
/*c
c rznew=r*z
c beta=rznew/rz
c rz=rznew
c*/
        rznew=0.0;
        for (n=0; n<nn; n++) {
          rznew=rznew+r[n]*z[n];
        }
        beta=rznew/rz;
        rz=rznew;
/*c
c p=z+beta*p
c*/
        for (n=0; n<nn; n++) {
          p[n]=z[n]+beta*p[n];
        }

        k=k+1;
      }

     }

/*c -------------------------------------------------- 
c          find the coordinate for i,j in matrice
c
c -------------------------------------------------- 
c*/
      int calja(int i, int j,int ia[], int ja[]) {
      int ind=ia[i];
      while( j>ja[ind] && ind<ia[i+1])  ind++;
      return ind;
      }

/*---------

		find the first derivatives of (x,y) at nodes

---------*/

     void dev_sp(int nsp, 
                   double xsp[], double ysp[], double x2sp[], double y2sp[],
                               double dsp[], double dxsp[][], double dysp[][]) 
     {
      int i;
      double u,ux,uy,h,a,b,c,d,d6=1./6., d3=1./3.,ux1,uy1;

// compute the tangent right of the location
      
      for (i=0; i<nsp-2; i++) {
       h = dsp[i];
       c = d3 * h;
       d = d6 * h;
       dxsp[i][1] = (xsp[i+1]-xsp[i])/h - c*x2sp[i] - d*x2sp[i+1];
       dysp[i][1] = (ysp[i+1]-ysp[i])/h - c*y2sp[i] - d*y2sp[i+1];
      }
      i=nsp-2;
       h = dsp[i];
       c = d3 * h;
       d = d6 * h;
       dxsp[i][1] = (xsp[0]-xsp[i])/h - c*x2sp[i] - d*x2sp[0];
       dysp[i][1] = (ysp[0]-ysp[i])/h - c*y2sp[i] - d*y2sp[0];
      

// compute the tangent left of the location
      
      for (i=1; i<nsp-1; i++) {
       h = dsp[i-1];
       c = d6 * h;
       d = d3 * h;
       dxsp[i][0] = (xsp[i]-xsp[i-1])/h + c*x2sp[i-1] + d*x2sp[i];
       dysp[i][0] = (ysp[i]-ysp[i-1])/h + c*y2sp[i-1] + d*y2sp[i];
      }
      i=nsp-2;
       h = dsp[i];
       c = d6 * h;
       d = d3 * h;
       dxsp[0][0] = (xsp[0]-xsp[i])/h + c*x2sp[i] + d*x2sp[0];
       dysp[0][0] = (ysp[0]-ysp[i])/h + c*y2sp[i] + d*y2sp[0];
      
     }
/*---------

		zero the matrice and the rhs when there is a change of 
		boundary condition along faces

---------*/

 
     void zero_spline(int i, int iasp[], int jasp[], 
                     double matsp[], double bxsp[], double bysp[]) 
     {
       bxsp[i]=0.;
       bysp[i]=0.;
       for (int j=iasp[i]; j<iasp[i+1]; j++) {
         if ( jasp[j] != i )  matsp[j]=0.;
      }
      
     }


// ******** smooth corners ***********

   	public void SmoothCorner(){
		int n1=0,n2,n3,face,cell,face2;
		int i,j,face_old,istart=-1;
		double xm,ym,dis,length;

                i=0;
		face = fbd[i];
		n1 = pseg[face][0];
		n2 = pseg[face][1];
		face2=pnodebdy[n1][0];
		n3 = pseg[face2][0];

                xm = 0.5*(x[n2]+x[n3]);
                ym = 0.5*(y[n2]+y[n3]);
		dis   = Math.sqrt((xm-x[n1])*(xm-x[n1])
		                + (ym-y[n1])*(ym-y[n1]));
		length= Math.sqrt((x[n2]-x[n1])*(x[n2]-x[n1])
		                + (y[n2]-y[n1])*(y[n2]-y[n1]));

		if (dis > 0.25*length) {
		    x[n1] = 0.5*(xm+x[n1]);
		    y[n1] = 0.5*(ym+y[n1]);
		}
		
		istart=n1;
		face=pnodebdy[n2][1];
		n1 = pseg[face][0];

	  while (istart != n1) {

		n2 = pseg[face][1];
		face2=pnodebdy[n1][0];
		n3 = pseg[face2][0];

                xm = 0.5*(x[n2]+x[n3]);
                ym = 0.5*(y[n2]+y[n3]);
		dis   = Math.sqrt((xm-x[n1])*(xm-x[n1])
		                + (ym-y[n1])*(ym-y[n1]));
		length= Math.sqrt((x[n2]-x[n1])*(x[n2]-x[n1])
		                + (y[n2]-y[n1])*(y[n2]-y[n1]));

		if (dis > 0.25*length) {
		    x[n1] = 0.5*(xm+x[n1]);
		    y[n1] = 0.5*(ym+y[n1]);
		}
		
		face=pnodebdy[n2][1];
		n1 = pseg[face][0];
	   }
	}

// ******** smooth mesh ***********

   	public void SmoothMesh(){
		int n1=0,n2,n3,face,cell,face2;
		int i,j,k,k1,nm;
		double xm,ym,dis,length,x1,y1,x2,y2,eps=1.e-2;
		int pbd[];
		
		pbd=new int[imax];
		for (i=0; i< imax; i++) pbd[i]=0;
		
		for (i=0; i<nfbd; i++) {
		   face = fbd[i];
		   n1 = pseg[face][0];
		   n2 = pseg[face][1];
		   pbd[n1]=1; pbd[n2]=1;
		}

                for (i=0; i< imax; i++) {
		    if (pbd[i]==0) {
		        xm=0.0; ym=0.0; nm=0;
			x1=x[i]; x2=x[i];
			y1=y[i]; y2=y[i];
		        for (j=nmit[i]; j<=nmit[i+1]-1; j++) {
			    cell = tmit[j];
			    k = imit[j];
			    k1 = k-1;
			    if (k1<0) k1=2;
			    n1 = tri[cell][k1];
			    xm += x[n1]; ym += y[n1]; nm++;
			    x1 = Math.min(x[n1],x1);
			    y1 = Math.min(y[n1],y1);
			    x2 = Math.max(x[n1],x2);
			    y2 = Math.max(y[n1],y2);
			}
			xm /= (double) nm;
			ym /= (double) nm;
			dis = Math.sqrt( (xm-x[i])*(xm-x[i])
			               + (ym-y[i])*(ym-y[i]) );
			length = Math.sqrt( (x2-x1)*(x2-x1)
			                  + (y2-y1)*(y2-y1) );
			if (dis>eps*length) { x[i]=xm; y[i]=ym; }
		    }
		}

	}
}
